unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SearchWrapper, ExtCtrls, ComCtrls;

type
  TfrmSearch = class(TForm)
    lvFoundFiles: TListView;
    Panel1: TPanel;
    SplitV: TSplitter;
    edDirectory: TEdit;
    edFileMask: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    btnBrowse: TButton;
    btnSearch: TButton;
    rgFileProperties: TGroupBox;
    chkbReadOnly: TCheckBox;
    chkbHidden: TCheckBox;
    chkbArchive: TCheckBox;
    chkbSystem: TCheckBox;
    chkbCompressed: TCheckBox;
    chkbDirectory: TCheckBox;
    SearchWrapper: TSearchWrapper;
    pbSearchProgress: TProgressBar;
    procedure btnBrowseClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure lvFoundFilesChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSearch: TfrmSearch;

implementation

Uses
  FileCtrl;
  
{$R *.DFM}

procedure TfrmSearch.FormCreate(Sender: TObject);
var
  SysDir: String;
begin
  SetLength(SysDir,GetSystemDirectory(nil,0));
  GetSystemDirectory(PChar(SysDir),Length(SysDir));
  edDirectory.Text:=SysDir;
end;

procedure TfrmSearch.btnBrowseClick(Sender: TObject);
var
  Dir: String;
begin
  If SelectDirectory('Select Directory To Search','',Dir) Then
    edDirectory.Text:=Dir;
end;

procedure TfrmSearch.btnSearchClick(Sender: TObject);
var
  i: Integer;
  Item: TListItem;
begin
  Screen.Cursor:=crHourGlass;
  try
    SearchWrapper.SearchDir:=edDirectory.Text;
    SearchWrapper.FileMask:=edFileMask.Text;
    SearchWrapper.Execute;

    lvFoundFiles.Items.BeginUpdate;
    try
      lvFoundFiles.Items.Clear;
      lvFoundFiles.Refresh;
      pbSearchProgress.Max:=SearchWrapper.FileCount;
      pbSearchProgress.Position:=0;
      For i:=0 to SearchWrapper.FileCount-1 do
      begin
        pbSearchProgress.StepIt;
        Item:=lvFoundFiles.Items.Add;
        Item.Caption:=SearchWrapper.Files[i].Name;
        Item.SubItems.Add(SearchWrapper.Files[i].DisplaySize+'KB');
        Item.SubItems.Add(SearchWrapper.Files[i].ShortName);
        Item.SubItems.Add(DateTimeToStr(SearchWrapper.Files[i].CreationDate));
        Item.SubItems.Add(DateTimeToStr(SearchWrapper.Files[i].LastAccessDate));
        Item.SubItems.Add(DateTimeToStr(SearchWrapper.Files[i].LastWriteDate));
      end;
      pbSearchProgress.Position:=0;
    finally
      lvFoundFiles.Items.EndUpdate;
    end;
  finally
    Screen.Cursor:=crDefault;
  end;
end;

procedure TfrmSearch.lvFoundFilesChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
var
  SelItem: TListItem;
  FileIndex: Integer;
begin
  SelItem:=lvFoundFiles.Selected;
  If SelItem<>nil Then
  begin
    FileIndex:=SelItem.Index;
    With SearchWrapper.Files[FileIndex] do
    begin
      chkbHidden.Checked:=Hidden;
      chkbReadOnly.Checked:=ReadOnly;
      chkbArchive.Checked:=Archive;
      chkbCompressed.Checked:=Compressed;
      chkbDirectory.Checked:=Directory;
      chkbSystem.Checked:=sysFile;
    end;
  end;
end;

end.
